# make sure the group where this stage is being included/extended has a SETTINGS_XML variable added as a file
# extend and replace MAVEN_CLI_OPTS in variables, example
# variables:
#   SETTINGS_XML: # file variable containing settings.xml
#   MAVEN_CLI_OPTS: "-B -s .m2/settings.xml"
#   MAVEN_TESTS: -DskipTests=true

build:
  stage: build
  image: maven:3.8.4-openjdk-8
  before_script:
    - mkdir -p .m2 
    - cp "$SETTINGS_XML" .m2/settings.xml
    # - PROJECT_NAME=$(mvn -q -Dexec.executable="echo" -Dexec.args='${project.artifactId}-${project.version}.jar' --non-recursive  org.codehaus.mojo:exec-maven-plugin:1.6.0:exec)
    - VERSION_TAG=$(mvn -q -Dexec.executable="echo" -Dexec.args='${project.version}' -s .m2/settings.xml org.codehaus.mojo:exec-maven-plugin:1.6.0:exec)
    - echo "VERACODE_FILEPATH=target/*.jar" > build.env
    - echo "VERSION=$VERSION_TAG" >> build.env
    - echo "JAVA_VERSION=8" >> build.env
  cache:
    - key: maven-setting
      paths:
        - .m2/
        - .mvn
  script:
    - echo "Test and prerequisite build"
    - mvn -N io.takari:maven:wrapper
    - mvn $MAVEN_CLI_OPTS $MAVEN_TESTS package
  artifacts:
    name: ${CI_PROJECT_NAME}_${CI_COMMIT_REF_NAME}_${CI_COMMIT_SHA}_build
    expire_in: 8 hour
    paths:
      - target/*.jar
    reports:
      dotenv: build.env
